DECLARE SUB MENU.CREDITS ()
DECLARE FUNCTION MENU.PICT% ()
DECLARE FUNCTION MENU.SIZE% (A$)
DECLARE SUB TILE2 (X%, Y%, N%)
DECLARE SUB MOUSE.CURSOR (A%)
DECLARE SUB TEXT3 (X%, Y%, T$, R%, G%, B%)
DECLARE SUB TEXT2 (X%, Y%, T$)
DECLARE SUB LOADFONT ()
DECLARE SUB TEXT (X%, Y%, T$)
DECLARE SUB TILE (X%, Y%, N%)
DECLARE SUB RETILE (A$, S%)
DECLARE SUB VESAMODE (X%, Y%)
DECLARE SUB MOUSE.SHOW (U%, V%, UO%, VO%)
DECLARE SUB MOUSE.HIDE (U%, V%, UO%, VO%)
DECLARE SUB MOUSE.INIT (X%, Y%, U%, V%)
DECLARE SUB MOUSE.READ (X%, Y%, L%, R%)
DECLARE SUB MENU.EXIT ()
DECLARE SUB POINT.SET (X%, Y%, R%, G%, B%)
DECLARE SUB POINT.GET (X%, Y%, R%, G%, B%)
DECLARE SUB PLAYGAME (CURSOR%, CUR1%, CUR2%)

'

DEFINT A-Z
RANDOMIZE TIMER

'

TYPE REGTYPE
  AX AS INTEGER
  BX AS INTEGER
  CX AS INTEGER
  DX AS INTEGER
  BP AS INTEGER
  SI AS INTEGER
  DI AS INTEGER
  FLAGS AS INTEGER
  DS AS INTEGER
  ES AS INTEGER
END TYPE
DIM SHARED REG AS REGTYPE, DEBUG
DIM SHARED CURRENTSEG, CURRENTX, CURRENTY, CURRENTBPP, CURRENTGRAN, CURRENTLINE AS LONG
DIM SHARED PAL(4096, 2), FPAL(129, 2), F2PAL(251, 2), F3PAL(1, 2), MPAL(225, 2)
DIM SHARED PIC(99), CHOSEN(1)
DIM SHARED MCUR(255, 2), MBACK(255, 2)

CONST PREDIR$ = ""

DEBUG = 0

'

CALL VESAMODE(400, 300)

IF DEBUG THEN
  CALL POINT.SET(0, 0, 255, 0, 0)
  CALL POINT.SET(0, CURRENTY - 1, 255, 0, 0)
  CALL POINT.SET(CURRENTX - 1, 0, 255, 0, 0)
  CALL POINT.SET(CURRENTX - 1, CURRENTY - 1, 255, 0, 0)
END IF


'
'TRU.CONVERT "MCURSOR", 0
'TRU.CONVERT "FONT3", 0
'TRU.CONVERT "FONT2", 0
'TRU.CONVERT "FONT", 0
'TRU.CONVERT "FANTASY", 1
'TRU.CONVERT "FRACTALS", 1
'TRU.CONVERT "BACK", 1
'END

CALL LOADFONT

DO
  CALL RETILE("BACK", DEBUG)
 
  SELECT CASE MENU.PICT
    CASE 0: CALL MENU.CREDITS
    CASE 1: A$ = "FANTASY": CURSOR = 3: CUR1 = 7: CUR2 = 7: EXIT DO
    CASE 2: A$ = "FRACTALS": CURSOR = 5: CUR1 = 0: CUR2 = 7: EXIT DO
    CASE 5: CALL MENU.CREDITS
  END SELECT
LOOP
 
DO
  SELECT CASE MENU.SIZE(A$)
    CASE 1: EXIT DO
    CASE 2: CALL VESAMODE(512, 384): EXIT DO
    CASE 3: CALL VESAMODE(640, 480): EXIT DO
    CASE 4: CALL VESAMODE(800, 600): EXIT DO
    CASE 5: CALL MENU.CREDITS
  END SELECT

  CALL RETILE("BACK", DEBUG)
LOOP
 
CALL RETILE(A$, 0)
CALL PLAYGAME(CURSOR, CUR1, CUR2)

CALL MENU.EXIT

SUB LOADFONT STATIC
  OPEN "B", 2, PREDIR$ + "FONT.TRU"
  OPEN "B", 3, PREDIR$ + "FONT2.TRU"
  OPEN "B", 4, PREDIR$ + "FONT3.TRU"
  OPEN "B", 5, PREDIR$ + "MCURSOR.TRU"

  FOR A = 0 TO UBOUND(FPAL)
    A$ = "   "
    GET 2, 1 + A * 3, A$
    FPAL(A, 0) = ASC(MID$(A$, 1, 1))
    FPAL(A, 1) = ASC(MID$(A$, 2, 1))
    FPAL(A, 2) = ASC(MID$(A$, 3, 1))
  NEXT A
 
  FOR A = 0 TO UBOUND(F2PAL)
    A$ = "   "
    GET 3, 1 + A * 3, A$
    F2PAL(A, 0) = ASC(MID$(A$, 1, 1))
    F2PAL(A, 1) = ASC(MID$(A$, 2, 1))
    F2PAL(A, 2) = ASC(MID$(A$, 3, 1))
  NEXT A
 
  FOR A = 0 TO UBOUND(F3PAL)
    A$ = "   "
    GET 4, 1 + A * 3, A$
    F3PAL(A, 0) = ASC(MID$(A$, 1, 1))
    F3PAL(A, 1) = ASC(MID$(A$, 2, 1))
    F3PAL(A, 2) = ASC(MID$(A$, 3, 1))
  NEXT A

  FOR A = 0 TO UBOUND(MPAL)
    A$ = "   "
    GET 5, 1 + A * 3, A$
    MPAL(A, 0) = ASC(MID$(A$, 1, 1))
    MPAL(A, 1) = ASC(MID$(A$, 2, 1))
    MPAL(A, 2) = ASC(MID$(A$, 3, 1))
  NEXT A

END SUB

SUB MENU.CREDITS
  CALL RETILE("BACK", DEBUG)

  CALL TEXT(-1, 18, "CREDITS")
  CALL TEXT3(-1, 65, "Memory Mania (M) 1999 Digisoft Corporation", 255, 255, 255)
  CALL TEXT2(-1, 89, "PROGRAMMING")
  CALL TEXT3(-1, 108, "Mark Jeronimus", 0, 160, 128)
  CALL TEXT3(-1, 118, "Thanks to Ralf Brown for making the ", 64, 128, 255)
  CALL TEXT3(-1, 127, "'Interrupt Index', the ultimate list of", 64, 128, 255)
  CALL TEXT3(-1, 136, "interrupts, memory and port descriptions.", 64, 128, 255)
  CALL TEXT2(-1, 151, "ART")
  CALL TEXT3(-1, 170, "Mark Jeronimus", 0, 160, 128)
  CALL TEXT3(-1, 179, "ID Software Inc.", 255, 0, 0)
  CALL TEXT3(-1, 187, "Ritual Entertainment", 105, 105, 255)
  CALL TEXT3(-1, 195, "Raven Software", 255, 224, 144)
  CALL TEXT3(-1, 203, "F. Slijkerman", 170, 0, 255)
  CALL TEXT3(-1, 211, "Origin of pictures inside the sets unknown", 128, 128, 128)
  CALL TEXT2(-1, 239, "IDEA")
  CALL TEXT3(-1, 258, "Dennis van Weeren, who was playing a", 170, 0, 0)
  CALL TEXT3(-1, 267, "stupid game of remember on his Amiga,", 170, 0, 0)
  CALL TEXT3(-1, 276, "asserted I can't make a similar game.", 170, 0, 0)

  CALL MOUSE.INIT(0, 0, 399, 299)
  CALL MOUSE.CURSOR(8)
  DO
    DO
      CALL MOUSE.SHOW(X, Y, 7, 7)

      IF DEBUG THEN
        CALL TEXT3(0, 0, " ", 0, 0, 0)
        CALL TEXT3(0, 0, STR$(X) + STR$(Y) + STR$(OK), 255, 255, 255)
      END IF

      XO = X: YO = Y: R = 0: L = 0
      WHILE X = XO AND Y = YO AND R = 0 AND L = 0
        CALL MOUSE.READ(X, Y, L, R)
      WEND

      CALL MOUSE.HIDE(XO, YO, 7, 7)
    LOOP UNTIL R OR L
    IF R THEN CALL MENU.EXIT
    IF L THEN EXIT SUB
  LOOP
END SUB

SUB MENU.EXIT STATIC
  CLOSE
  SCREEN 2: SCREEN 0
  END
END SUB

FUNCTION MENU.PICT STATIC
  CALL RETILE("BACK", 1)
 
  CALL TEXT(-1, 0, "MEMORY")
  CALL TEXT(-1, 40, "MANIA")
  CALL TEXT3(322, 126, "Credits", 25, 170, 170)

  CALL TEXT2(-1, 188, "SELECT PICTURE SETB")
 
  CALL RETILE("FANTASY", 1)
  CALL TEXT2(100, 239, "FANTASY")
  CALL TEXT3(100, 254, "64 PCS.", 0, 0, 64)
  CALL TILE(0, 225, 0)

  CALL RETILE("FRACTALS", 1)
  CALL TEXT2(170, 269, "FRACTALS")
  CALL TEXT3(234, 261, "100 PCS.", 0, 0, 64)
  CALL TILE(300, 225, 0)
 
  CALL MOUSE.INIT(0, 112, 399, 299)

'

  OKO = -1
  DO
    DO
      OK = 0
      IF X < 100 AND Y > 224 THEN OK = 1
      IF X > 299 AND Y > 224 THEN OK = 2
      IF X > 320 AND X < 384 AND Y > 124 AND Y < 134 THEN OK = 5
      IF OK <> OKO THEN CALL MOUSE.CURSOR(1 + SGN(OK)): OKO = OK
      
      CALL MOUSE.SHOW(X, Y, SGN(OK) * 7, SGN(OK) * 7)

      IF DEBUG THEN
        CALL TEXT3(0, 0, " ", 0, 0, 0)
        CALL TEXT3(0, 0, STR$(X) + STR$(Y) + STR$(OK), 255, 255, 255)
      END IF

      XO = X: YO = Y: R = 0: L = 0
      WHILE X = XO AND Y = YO AND R = 0 AND L = 0
        CALL MOUSE.READ(X, Y, L, R)
      WEND

      CALL MOUSE.HIDE(XO, YO, SGN(OK) * 7, SGN(OK) * 7)
    LOOP UNTIL R OR L

    IF R THEN CALL MENU.EXIT
    IF L > 0 AND OK > 0 THEN EXIT DO
  LOOP

  MENU.PICT = OK
END FUNCTION

FUNCTION MENU.SIZE (A$)
  CALL RETILE("BACK", 1)

  CALL TILE(0, 150, 0)
  CALL TILE(0, 225, 0)
  CALL TILE(100, 150, 0)
  CALL TILE(100, 225, 0)
  CALL TILE(200, 150, 0)
  CALL TILE(200, 225, 0)
  CALL TILE(300, 150, 0)
  CALL TILE(300, 225, 0)

  CALL TEXT2(-1, 166, "PICTURE SETB " + A$)
  CALL TEXT2(-1, 192, "SELECT GRID SIZEB")

  CALL TEXT2(25, 255, "4X4")
  CALL TEXT2(125, 255, "5X5")
  CALL TEXT3(126, 274, "REST 1", 170, 96, 32)
  CALL TEXT2(225, 255, "6X6")
  CALL TEXT2(325, 255, "8X8")

'

  OKO = -1
  DO
    DO
      OK = 0
      IF X > 10 AND X < 89 AND Y > 239 AND Y < 285 THEN OK = 1
      IF X > 110 AND X < 189 AND Y > 239 AND Y < 285 THEN OK = 2
      IF X > 210 AND X < 289 AND Y > 239 AND Y < 285 THEN OK = 3
      IF X > 310 AND X < 389 AND Y > 239 AND Y < 285 THEN OK = 4
      IF X > 320 AND X < 384 AND Y > 124 AND Y < 134 THEN OK = 5
      IF OK <> OKO THEN CALL MOUSE.CURSOR(1 + SGN(OK)): OKO = OK
    
      CALL MOUSE.SHOW(X, Y, SGN(OK) * 7, SGN(OK) * 7)

      IF DEBUG THEN
        CALL TEXT3(0, 0, " ", 0, 0, 0)
        CALL TEXT3(0, 0, STR$(X) + STR$(Y) + STR$(OK), 255, 255, 255)
      END IF

      XO = X: YO = Y: R = 0: L = 0
      WHILE X = XO AND Y = YO AND R = 0 AND L = 0
        CALL MOUSE.READ(X, Y, L, R)
      WEND

      CALL MOUSE.HIDE(XO, YO, SGN(OK) * 7, SGN(OK) * 7)
    LOOP UNTIL R OR L

    IF R THEN CALL MENU.EXIT
    IF L > 0 AND OK > 0 THEN EXIT DO
  LOOP

  MENU.SIZE = OK
END FUNCTION

SUB MOUSE.CURSOR (A) STATIC
  SEEK 5, 769 + 384& * A
  FOR A = 0 TO 255 STEP 2
    A$ = "   "
    GET 5, , A$
    R = ASC(MID$(A$, 1, 1))
    G = ASC(MID$(A$, 2, 1))
    B = ASC(MID$(A$, 3, 1))
    COL2 = R * 16 + G \ 16
    COL1 = (G MOD 16) * 256 + B
   
    MCUR(A, 0) = MPAL(COL2, 0)
    MCUR(A, 1) = MPAL(COL2, 1)
    MCUR(A, 2) = MPAL(COL2, 2)
    IF COL2 = 0 THEN MCUR(A, 0) = -1
  
    MCUR(A + 1, 0) = MPAL(COL1, 0)
    MCUR(A + 1, 1) = MPAL(COL1, 1)
    MCUR(A + 1, 2) = MPAL(COL1, 2)
    IF COL1 = 0 THEN MCUR(A + 1, 0) = -1
  NEXT
END SUB

SUB MOUSE.HIDE (U, V, UO, VO) STATIC
  WAIT &H3DA, 8
  A = 0
  FOR Y = V TO V + 15
    FOR X = U TO U + 15
      IF MBACK(A, 0) > -1 THEN CALL POINT.SET(X - UO, Y - UO, MBACK(A, 0), MBACK(A, 1), MBACK(A, 2))
      A = A + 1
    NEXT
  NEXT
END SUB

SUB MOUSE.INIT (X, Y, U, V) STATIC
  REG.AX = &H0
  CALL INTERRUPTX(&H33, REG, REG)
  IF NOT REG.AX THEN MENU.EXIT
 
  REG.AX = &H4
  REG.CX = X + U
  REG.DX = (Y + V) \ 2
  CALL INTERRUPTX(&H33, REG, REG)
  REG.AX = &H7
  REG.CX = X * 2
  REG.DX = U * 2
  CALL INTERRUPTX(&H33, REG, REG)
  REG.AX = &H8
  REG.CX = Y
  REG.DX = V
  CALL INTERRUPTX(&H33, REG, REG)
END SUB

SUB MOUSE.READ (X, Y, L, R) STATIC
  REG.AX = &H3
  CALL INTERRUPTX(&H33, REG, REG)
  X = REG.CX \ 2
  Y = REG.DX
  L = REG.BX AND 1: R = REG.BX AND 2
END SUB

SUB MOUSE.SHOW (U, V, UO, VO) STATIC
  A = 0
  FOR Y = V TO V + 15
    FOR X = U TO U + 15
      IF MCUR(A, 0) > -1 THEN
        CALL POINT.GET(X - UO, Y - UO, R, G, B)
        MBACK(A, 0) = R
        MBACK(A, 1) = G
        MBACK(A, 2) = B
        CALL POINT.SET(X - UO, Y - UO, MCUR(A, 0), MCUR(A, 1), MCUR(A, 2))
      ELSE
        MBACK(A, 0) = -1
      END IF
      A = A + 1
    NEXT
  NEXT
END SUB

SUB PLAYGAME (CURSOR, CUR1, CUR2)
  TILES = CURRENTX \ 100
  U = (CURRENTX - TILES * 100) \ 2
  V = U * 3 \ 4
  CUR = CUR1
 
  CALL MOUSE.INIT(0, 0, CURRENTX - 1, CURRENTY - 1)

'

  CALL MOUSE.CURSOR((CURSOR))
  DO
    DO
      OK = (X - U) \ 100 + ((Y - V) \ 75) * TILES
      IF X < U OR Y < V OR X > CURRENTX - U - 1 OR Y > CURRENTY - V - 1 THEN OK = -1
      IF TILES = 5 AND OK = 24 THEN OK = -1
     
      CALL MOUSE.SHOW(X, Y, CUR, CUR)

      IF DEBUG THEN
        CALL TEXT3(0, 0, " ", 0, 0, 0)
        CALL TEXT3(0, 0, STR$(X) + STR$(Y) + STR$(CHOSEN), 255, 255, 255)
      END IF

      XO = X: YO = Y: R = 0: L = 0
      WHILE X = XO AND Y = YO AND R = 0 AND L = 0
        CALL MOUSE.READ(X, Y, L, R)
      WEND

      CALL MOUSE.HIDE(XO, YO, CUR, CUR)
    LOOP UNTIL R OR L

    IF R THEN CALL MENU.EXIT
    IF L > 0 AND OK >= 0 THEN
      IF PIC(OK) > 0 THEN
        PIC(OK) = -PIC(OK)
        CALL TILE2(U + (OK MOD TILES) * 100, V + (OK \ TILES) * 75, 1)
        CALL TILE(U + (OK MOD TILES) * 100, V + (OK \ TILES) * 75, ABS(PIC(OK)))
        
        CHOSEN(CHOSEN) = OK
        CHOSEN = CHOSEN + 1
        CALL MOUSE.CURSOR((CURSOR + 2 - CHOSEN))
        CUR = CUR2

        IF CHOSEN = 2 THEN
          CUR = CUR1
          SLEEP 1
          IF PIC(CHOSEN(0)) = PIC(CHOSEN(1)) THEN
            CALL TILE2(U + (CHOSEN(0) MOD TILES) * 100, V + (CHOSEN(0) \ TILES) * 75, 1)
            CALL TILE2(U + (CHOSEN(1) MOD TILES) * 100, V + (CHOSEN(1) \ TILES) * 75, 1)

            FOUND = FOUND + 1
            IF FOUND = TILES ^ 2 \ 2 THEN
              CALL TEXT(-1, CURRENTY \ 4, "YOU WIN")
              CALL TEXT2(-1, CURRENTY \ 4 + 40, "JJJJJJJJJJJJJJJ")
              CALL TEXT2(-1, CURRENTY / 1.8, "SCOREB " + STR$(CINT(TILES ^ 2 * 1000 / STEPS)))
              I$ = INPUT$(1)
              EXIT SUB
            END IF
          ELSE
            PIC(CHOSEN(0)) = ABS(PIC(CHOSEN(0))): PIC(OK) = ABS(PIC(OK))
            CALL TILE(U + (CHOSEN(0) MOD TILES) * 100, V + (CHOSEN(0) \ TILES) * 75, 0)
            CALL TILE(U + (CHOSEN(1) MOD TILES) * 100, V + (CHOSEN(1) \ TILES) * 75, 0)
          END IF
          CHOSEN = 0
        END IF
        STEPS = STEPS + 1
      ELSEIF CHOSEN = 1 AND OK = CHOSEN(0) THEN
        CALL TILE2(U + (OK MOD TILES) * 100, V + (OK \ TILES) * 75, 1)
        CALL TILE(U + (OK MOD TILES) * 100, V + (OK \ TILES) * 75, ABS(PIC(OK)))
      ELSE
        CALL TILE(U + (OK MOD TILES) * 100, V + (OK \ TILES) * 75, ABS(PIC(OK)))
        CALL TILE2(U + (OK MOD TILES) * 100, V + (OK \ TILES) * 75, 1)
      END IF
    END IF
  LOOP
END SUB

SUB POINT.GET (X, Y, R, G, B) STATIC
  IF X < 0 THEN EXIT SUB
  IF Y < 0 THEN EXIT SUB
  IF X > CURRENTX - 1 THEN EXIT SUB
  IF Y > CURRENTY - 1 THEN EXIT SUB

  DEF SEG = CURRENTSEG
  A& = X * CURRENTBPP + Y * CURRENTLINE

  GR = A& \ 65536
  A& = A& MOD 65536
  IF GR + 1 <> CURRENTGRAN THEN
    CURRENTGRAN = GR + 1
    REG.AX = &H4F05: REG.BX = &H0: REG.CX = &H0: REG.DX = GR
    CALL INTERRUPTX(&H10, REG, REG)
  END IF
  B = PEEK(A&)
  G = PEEK(A& + 1)
  R = PEEK(A& + 2)
END SUB

SUB POINT.SET (X, Y, R, G, B) STATIC
  IF X < 0 THEN EXIT SUB
  IF Y < 0 THEN EXIT SUB
  IF X > CURRENTX - 1 THEN EXIT SUB
  IF Y > CURRENTY - 1 THEN EXIT SUB

  DEF SEG = CURRENTSEG
  A& = X * CURRENTBPP + Y * CURRENTLINE
  
  GR = A& \ 65536
  A& = A& MOD 65536
  IF GR + 1 <> CURRENTGRAN THEN
    CURRENTGRAN = GR + 1
    REG.AX = &H4F05: REG.BX = &H0: REG.CX = &H0: REG.DX = GR
    CALL INTERRUPTX(&H10, REG, REG)
  END IF
  POKE A&, B
  POKE A& + 1, G
  POKE A& + 2, R
END SUB

SUB RETILE (A$, S) STATIC
  CLOSE 1
  OPEN "B", 1, PREDIR$ + A$ + ".TRU"
  FOR A = 0 TO 4095
    A$ = "   "
    GET 1, 1 + A * 3, A$
    PAL(A, 0) = ASC(MID$(A$, 1, 1))
    PAL(A, 1) = ASC(MID$(A$, 2, 1))
    PAL(A, 2) = ASC(MID$(A$, 3, 1))
  NEXT A
  NUMPICS = (LOF(1) - 34788) \ 11250

  TILES = CURRENTX \ 100

  IF S = 1 THEN EXIT SUB
  
  FOR A = 0 TO NUMPICS - 1
    PIC(A) = A + 2
  NEXT
  FOR A = NUMPICS - 1 TO 1 STEP -1
    B = INT(RND * (A - 1))
    SWAP PIC(A), PIC(B)
  NEXT
  B = TILES ^ 2 \ 2
  FOR A = 0 TO B - 1
    PIC(A + B) = PIC(A)
  NEXT
  FOR A = B * 2 - 1 TO 1 STEP -1
    B = INT(RND * (A - 1) + 1)
    SWAP PIC(A), PIC(B)
  NEXT
 
  X = (CURRENTX - TILES * 100) \ 2
  Y = X * 3 \ 4
  Z = 0: Z1 = 1: Z2 = 1: Z3 = TILES
  A = 0
  DO
    IF DEBUG THEN
      CALL TILE(X, Y, PIC(A))
      CALL TILE2(X, Y, 0)
    ELSEIF TILES = 5 AND A = 24 THEN
      CALL TILE2(X, Y, 1)
    ELSE
      CALL TILE(X, Y, 0)
    END IF
    SELECT CASE Z
      CASE 0: X = X + 100: A = A + 1:     Z1 = Z1 + 1: IF Z1 = Z3 THEN Z1 = 0: Z = 1: Z2 = 2
      CASE 1: Y = Y + 75:  A = A + TILES: Z1 = Z1 + 1: IF Z1 = Z3 THEN Z1 = 0: Z = 2: Z2 = 1
      CASE 2: X = X - 100: A = A - 1:     Z1 = Z1 + 1: IF Z1 = Z3 THEN Z1 = 0: Z = 3: Z2 = 2
      CASE 3: Y = Y - 75:  A = A - TILES: Z1 = Z1 + 1: IF Z1 = Z3 THEN Z1 = 0: Z = 0: Z2 = 1
    END SELECT
    IF Z3 = 0 THEN EXIT DO
    IF Z2 = 2 THEN Z2 = 0: Z3 = Z3 - 1
    IF Z3 < TILES - 1 AND S THEN EXIT SUB
  LOOP
END SUB

SUB TEXT (X, Y, T$) STATIC
  IF X = -1 THEN X = (CURRENTX - 35 * LEN(T$)) \ 2
  IF X + 35 * LEN(T$) > CURRENTX THEN STOP

  C = 0
  FOR X = X TO X + 35 * (LEN(T$) - 1) STEP 35
    C = C + 1
    N = ASC(MID$(T$, C, 1)) - 65

    IF N >= 0 AND N < 26 THEN
      SEEK 2, 769 + 2100& * N
      FOR A = 0 TO 1399 STEP 2
        A$ = "   "
        GET 2, , A$
        R = ASC(MID$(A$, 1, 1))
        G = ASC(MID$(A$, 2, 1))
        B = ASC(MID$(A$, 3, 1))
        COL2 = R * 16 + G \ 16
        COL1 = (G MOD 16) * 256 + B
     
        IF COL2 <> 0 THEN CALL POINT.SET(X + A MOD 35, Y + A \ 35, FPAL(COL2, 0), FPAL(COL2, 1), FPAL(COL2, 2))
        IF COL1 <> 0 THEN CALL POINT.SET(X + (A + 1) MOD 35, Y + (A + 1) \ 35, FPAL(COL1, 0), FPAL(COL1, 1), FPAL(COL1, 2))
      NEXT
    END IF
  NEXT
      
END SUB

SUB TEXT2 (X, Y, T$) STATIC
  IF X = -1 THEN X = (CURRENTX - 16 * LEN(T$)) \ 2
  IF X + 16 * LEN(T$) > CURRENTX THEN STOP

  C = 0
  FOR X = X TO X + 16 * (LEN(T$) - 1) STEP 16
    C = C + 1
    N = ASC(MID$(T$, C, 1)) - 64
    IF N < -6 AND N > -17 THEN N = N + 43

    IF N >= 0 AND N < 37 THEN
      SEEK 3, 769 + 360& * N
      FOR A = 0 TO 239 STEP 2
        A$ = "   "
        GET 3, , A$
        R = ASC(MID$(A$, 1, 1))
        G = ASC(MID$(A$, 2, 1))
        B = ASC(MID$(A$, 3, 1))
        COL2 = R * 16 + G \ 16
        COL1 = (G MOD 16) * 256 + B
    
        IF COL2 <> 0 THEN CALL POINT.SET(X + A MOD 16, Y + A \ 16, F2PAL(COL2, 0), F2PAL(COL2, 1), F2PAL(COL2, 2))
        IF COL1 <> 0 THEN CALL POINT.SET(X + A MOD 16 + 1, Y + A \ 16, F2PAL(COL1, 0), F2PAL(COL1, 1), F2PAL(COL1, 2))
      NEXT
    END IF
  NEXT
     
END SUB

SUB TEXT3 (X, Y, T$, R, G, B) STATIC
  IF X = -1 THEN X = (CURRENTX - 8 * LEN(T$)) \ 2
  IF X + 8 * LEN(T$) > CURRENTX THEN STOP

  C = 0
  FOR X = X TO X + 8 * (LEN(T$) - 1) STEP 8
    C = C + 1
    N = ASC(MID$(T$, C, 1)) - 33

    IF N >= 0 AND N < 95 THEN
      SEEK 4, 769 + 96 * N
      FOR A = 0 TO 63 STEP 2
        A$ = "   "
        GET 4, , A$
        U = ASC(MID$(A$, 1, 1))
        V = ASC(MID$(A$, 2, 1))
        W = ASC(MID$(A$, 3, 1))
        COL2 = U * 16 + V \ 16
        COL1 = (V MOD 16) * 256 + W
   
        IF COL2 <> 0 THEN CALL POINT.SET(X + A MOD 8, Y + A \ 8, R, G, B)
        IF COL1 <> 0 THEN CALL POINT.SET(X + A MOD 8 + 1, Y + A \ 8, R, G, B)
      NEXT
    END IF
  NEXT
    
END SUB

SUB TILE (X, Y, N) STATIC
  SEEK 1, 12289 + 11250& * N
  FOR A = 0 TO 7499 STEP 2
    A$ = "   "
    GET 1, , A$

    R = ASC(MID$(A$, 1, 1))
    G = ASC(MID$(A$, 2, 1))
    B = ASC(MID$(A$, 3, 1))
    COL2 = R * 16 + G \ 16
    COL1 = (G MOD 16) * 256 + B

    CALL POINT.SET(X + A MOD 100, Y + A \ 100, PAL(COL2, 0), PAL(COL2, 1), PAL(COL2, 2))
    CALL POINT.SET(X + A MOD 100 + 1, Y + A \ 100, PAL(COL1, 0), PAL(COL1, 1), PAL(COL1, 2))
  NEXT
END SUB

SUB TILE2 (X, Y, N) STATIC
  SEEK 1, 12289 + 11250& * N
  FOR A = 0 TO 7499 STEP 2
    A$ = "   "
    GET 1, , A$

    R = ASC(MID$(A$, 1, 1))
    G = ASC(MID$(A$, 2, 1))
    B = ASC(MID$(A$, 3, 1))
    COL2 = R * 16 + G \ 16
    COL1 = (G MOD 16) * 256 + B

    U = X + A MOD 100: V = Y + A \ 100
   
    CALL POINT.GET(U, V, R, G, B)
    'CALL POINT.SET(U, V, (PAL(COL2, 0) * 2 + R) \ 3, (PAL(COL2, 1) * 2 + G) \ 3, (PAL(COL2, 2) * 2 + B) \ 3)
    CALL POINT.SET(U, V, (PAL(COL2, 0) * 4 + R) \ 5, (PAL(COL2, 1) * 4 + G) \ 5, (PAL(COL2, 2) * 4 + B) \ 5)
    CALL POINT.GET(U + 1, V, R, G, B)
    'CALL POINT.SET(U + 1, V, (PAL(COL1, 0) * 2 + R) \ 3, (PAL(COL1, 1) * 2 + G) \ 3, (PAL(COL1, 2) * 2 + B) \ 3)
    CALL POINT.SET(U + 1, V, (PAL(COL1, 0) * 4 + R) \ 5, (PAL(COL1, 1) * 4 + G) \ 5, (PAL(COL1, 2) * 4 + B) \ 5)
  NEXT
END SUB

SUB TRU.CONVERT (A$, N) STATIC
  VESAMODE 800, 600
  OPEN "B", 1, PREDIR$ + A$ + ".RAW"
  OPEN "B", 2, PREDIR$ + A$ + ".TRU"

  NUMPAL = 0
  COL2 = -1
  FOR A& = 0 TO (LOF(1) \ 3) - 1
    A$ = "   "
    GET 1, , A$
    R = ASC(MID$(A$, 1, 1))
    G = ASC(MID$(A$, 2, 1))
    B = ASC(MID$(A$, 3, 1))
    CALL POINT.SET(A& MOD 800, A& \ 800, R, G, B)

    FOUND = -1
    FOR A = 0 TO NUMPAL - 1
      IF PAL(A, 0) = R THEN
        IF PAL(A, 1) = G THEN
          IF PAL(A, 2) = B THEN
            FOUND = A
            EXIT FOR
          END IF
        END IF
      END IF
    NEXT A
    IF FOUND = -1 THEN
      PAL(NUMPAL, 0) = R
      PAL(NUMPAL, 1) = G
      PAL(NUMPAL, 2) = B
      A$ = CHR$(R) + CHR$(G) + CHR$(B)
      PUT 2, 1 + NUMPAL * 3, A$
   
      CALL POINT.SET((475904 + NUMPAL) MOD 800, (475904 + NUMPAL) \ 800, R, G, B)

      FOUND = NUMPAL
      NUMPAL = NUMPAL + 1
    END IF

    COL1 = FOUND
    IF COL2 = -1 THEN
      COL2 = COL1
    ELSE
      R = COL2 \ 16
      G = (COL2 MOD 16) * 16 + COL1 \ 256
      B = COL1 MOD 256
      A$ = CHR$(R) + CHR$(G) + CHR$(B)
     
      IF N THEN
        PUT 2, 12288 + A& * 3 \ 2, A$
      ELSE
        PUT 2, 768 + A& * 3 \ 2, A$
      END IF

      COL2 = -1
    END IF
  NEXT
  CLOSE

  CALL LOADFONT
  CALL TEXT3(-1, 592, "", 0, 0, 0)
  CALL TEXT3(-1, 592, STR$(NUMPAL - 1), 255, 255, 255)
  I$ = INPUT$(1)
  CLOSE
END SUB

SUB TRU.LEES (A$) STATIC
  OPEN "B", 1, PREDIR$ + A$ + ".TRU"
  FOR A = 0 TO 4095
    A$ = "   "
    GET 1, 1 + A * 3, A$
    PAL(A, 0) = ASC(MID$(A$, 1, 1))
    PAL(A, 1) = ASC(MID$(A$, 2, 1))
    PAL(A, 2) = ASC(MID$(A$, 3, 1))
    CALL POINT.SET((475904 + A) MOD 800, (475904 + A) \ 800, PAL(A, 0), PAL(A, 1), PAL(A, 2))
  NEXT A
  FOR A& = 0 TO (LOF(1) * 2 \ 3) - 8193 STEP 2
    A$ = "   "
    GET 1, , A$
    R = ASC(MID$(A$, 1, 1))
    G = ASC(MID$(A$, 2, 1))
    B = ASC(MID$(A$, 3, 1))
    COL2 = R * 16 + G \ 16
    COL1 = (G MOD 16) * 256 + B
   
    CALL POINT.SET(A& MOD 18, A& \ 18, PAL(COL2, 0), PAL(COL2, 1), PAL(COL2, 2))
    CALL POINT.SET(A& MOD 18 + 1, A& \ 18, PAL(COL1, 0), PAL(COL1, 1), PAL(COL1, 2))

  NEXT
  CLOSE
END SUB

SUB VESAMODE (X, Y) STATIC
  DIM ASMDATA AS STRING * 256
 
  REG.AX = &H4F00
  REG.ES = VARSEG(ASMDATA)
  REG.DI = VARPTR(ASMDATA)

  CALL INTERRUPTX(&H10, REG, REG)

  DEF SEG = CVI(MID$(ASMDATA, &H11, 2))
  PTR = CVI(MID$(ASMDATA, &HF, 2))
  FOUND = -1
  DO
    REG.CX = CVI(CHR$(PEEK(PTR)) + CHR$(PEEK(PTR + 1)))
    IF REG.CX = -1 THEN EXIT DO

    REG.AX = &H4F01
    REG.ES = VARSEG(ASMDATA)
    REG.DI = VARPTR(ASMDATA)
    CALL INTERRUPTX(&H10, REG, REG)

    CURRENTX = CVI(MID$(ASMDATA, &H13, 2))
    CURRENTY = CVI(MID$(ASMDATA, &H15, 2))
    CURRENTBPP = ASC(MID$(ASMDATA, &H1A, 1))
    CURRENTSEG = CVI(MID$(ASMDATA, &H9, 2))
    CURRENTLINE = CVI(MID$(ASMDATA, &H11, 2))
   
    IF X = CURRENTX AND Y = CURRENTY AND CURRENTBPP > 16 THEN FOUND = REG.CX: EXIT DO
    PTR = PTR + 2
  LOOP

  IF FOUND < 0 THEN
    X = INT(X * .080001) * 16: Y = X * 3 \ 4
    PRINT X, Y
    I$ = INPUT$(1)
    VESAMODE X, Y
  END IF

  CURRENTBPP = CURRENTBPP / 8

  SCREEN 13
  REG.AX = &H4F02
  REG.BX = FOUND
  CALL INTERRUPTX(&H10, REG, REG)
END SUB

